import * as vue from 'vue';
import { PropType } from 'vue';
import * as _oku_ui_provide from '@oku-ui/provide';
import { Scope } from '@oku-ui/provide';
import { OkuElement, PrimitiveProps } from '@oku-ui/primitive';

type CheckedState = boolean | string | number | undefined | 'indeterminate';

declare const createCheckboxScope: _oku_ui_provide.CreateScope;
type CheckboxNaviteElement = Omit<OkuElement<'button', true>, 'checked' | 'defaultChecked'>;
type CheckboxElement = HTMLButtonElement;
interface CheckboxProps extends PrimitiveProps {
    modelValue?: CheckedState;
    checked?: CheckedState;
    defaultChecked?: CheckedState;
    required?: boolean;
    scopeCheckbox?: Scope;
    name?: string;
    disabled?: boolean;
    value?: string;
}
type CheckboxEmits = {
    'update:modelValue': [checked: CheckedState];
    'checkedChange': [checked: CheckedState];
    'keydown': [event: KeyboardEvent];
    'click': [event: MouseEvent];
};
declare const checkboxProps: {
    props: {
        modelValue: {
            type: PropType<CheckedState>;
            default: undefined;
        };
        checked: {
            type: PropType<CheckedState>;
            default: undefined;
        };
        defaultChecked: {
            type: PropType<boolean | "indeterminate" | undefined>;
            default: undefined;
        };
        required: {
            type: PropType<boolean | undefined>;
            default: undefined;
        };
        name: {
            type: PropType<string | undefined>;
            default: undefined;
        };
        disabled: {
            type: PropType<boolean | undefined>;
            default: undefined;
        };
        value: {
            type: PropType<string | undefined>;
            default: undefined;
        };
    };
    emits: {
        'update:modelValue': (checked: CheckedState) => boolean;
        checkedChange: (checked: CheckedState) => boolean;
        keydown: (event: KeyboardEvent) => boolean;
        click: (event: MouseEvent) => boolean;
    };
};
declare const OkuCheckbox: {
    new (...args: any[]): {
        $: vue.ComponentInternalInstance;
        $data: {};
        $props: {
            checked?: CheckedState;
            defaultChecked?: boolean | "indeterminate" | undefined;
            disabled?: boolean | undefined;
            name?: string | undefined;
            required?: boolean | undefined;
            value?: string | undefined;
            modelValue?: CheckedState;
            asChild?: boolean | undefined;
            onKeydown?: ((event: KeyboardEvent) => any) | undefined;
            onClick?: ((event: MouseEvent) => any) | undefined;
            style?: unknown;
            class?: unknown;
            key?: string | number | symbol | undefined;
            ref?: vue.VNodeRef | undefined;
            ref_for?: boolean | undefined;
            ref_key?: string | undefined;
            "onUpdate:modelValue"?: ((checked: CheckedState) => any) | undefined;
            onCheckedChange?: ((checked: CheckedState) => any) | undefined;
            readonly scopeOkuCheckbox?: Scope<any>;
            onVnodeBeforeMount?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeMounted?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeBeforeUpdate?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>, oldVNode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>, oldVNode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeUpdated?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>, oldVNode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>, oldVNode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeBeforeUnmount?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeUnmounted?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
        };
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: vue.Slot<any> | undefined;
        }>;
        $root: vue.ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, vue.ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null;
        $parent: vue.ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, vue.ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null;
        $emit: ((event: "click", event: MouseEvent) => void) & ((event: "update:modelValue", checked: CheckedState) => void) & ((event: "checkedChange", checked: CheckedState) => void) & ((event: "keydown", event: KeyboardEvent) => void);
        $el: any;
        $options: vue.ComponentOptionsBase<Readonly<vue.ExtractPropTypes<{
            asChild: BooleanConstructor;
            scopeOkuCheckbox: {
                type: PropType<Scope<any>>;
                required: boolean;
            };
            modelValue: {
                type: PropType<CheckedState>;
                default: undefined;
            };
            checked: {
                type: PropType<CheckedState>;
                default: undefined;
            };
            defaultChecked: {
                type: PropType<boolean | "indeterminate" | undefined>;
                default: undefined;
            };
            required: {
                type: PropType<boolean | undefined>;
                default: undefined;
            };
            name: {
                type: PropType<string | undefined>;
                default: undefined;
            };
            disabled: {
                type: PropType<boolean | undefined>;
                default: undefined;
            };
            value: {
                type: PropType<string | undefined>;
                default: undefined;
            };
        }>> & {
            onKeydown?: ((event: KeyboardEvent) => any) | undefined;
            onClick?: ((event: MouseEvent) => any) | undefined;
            "onUpdate:modelValue"?: ((checked: CheckedState) => any) | undefined;
            onCheckedChange?: ((checked: CheckedState) => any) | undefined;
        }, () => (boolean | vue.VNode<vue.RendererNode, vue.RendererElement, {
            [key: string]: any;
        }>)[], unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {
            'update:modelValue': (checked: CheckedState) => boolean;
            checkedChange: (checked: CheckedState) => boolean;
            keydown: (event: KeyboardEvent) => boolean;
            click: (event: MouseEvent) => boolean;
        }, string, {
            checked: CheckedState;
            defaultChecked: boolean | "indeterminate" | undefined;
            disabled: boolean | undefined;
            name: string | undefined;
            required: boolean | undefined;
            value: string | undefined;
            modelValue: CheckedState;
            asChild: boolean;
        }, {}, string, {}> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: vue.DebuggerEvent) => void) | ((e: vue.DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: vue.DebuggerEvent) => void) | ((e: vue.DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: vue.ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, vue.ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null, info: string) => boolean | void) | ((err: unknown, instance: vue.ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, vue.ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof vue.nextTick;
        $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (args_0: R, args_1: R) => any : (...args: any) => any, options?: vue.WatchOptions<boolean> | undefined): vue.WatchStopHandle;
    } & Readonly<vue.ExtractPropTypes<{
        asChild: BooleanConstructor;
        scopeOkuCheckbox: {
            type: PropType<Scope<any>>;
            required: boolean;
        };
        modelValue: {
            type: PropType<CheckedState>;
            default: undefined;
        };
        checked: {
            type: PropType<CheckedState>;
            default: undefined;
        };
        defaultChecked: {
            type: PropType<boolean | "indeterminate" | undefined>;
            default: undefined;
        };
        required: {
            type: PropType<boolean | undefined>;
            default: undefined;
        };
        name: {
            type: PropType<string | undefined>;
            default: undefined;
        };
        disabled: {
            type: PropType<boolean | undefined>;
            default: undefined;
        };
        value: {
            type: PropType<string | undefined>;
            default: undefined;
        };
    }>> & {
        onKeydown?: ((event: KeyboardEvent) => any) | undefined;
        onClick?: ((event: MouseEvent) => any) | undefined;
        "onUpdate:modelValue"?: ((checked: CheckedState) => any) | undefined;
        onCheckedChange?: ((checked: CheckedState) => any) | undefined;
    } & vue.ShallowUnwrapRef<() => (boolean | vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>)[]> & {} & vue.ComponentCustomProperties & {};
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & vue.ComponentOptionsBase<Readonly<vue.ExtractPropTypes<{
    asChild: BooleanConstructor;
    scopeOkuCheckbox: {
        type: PropType<Scope<any>>;
        required: boolean;
    };
    modelValue: {
        type: PropType<CheckedState>;
        default: undefined;
    };
    checked: {
        type: PropType<CheckedState>;
        default: undefined;
    };
    defaultChecked: {
        type: PropType<boolean | "indeterminate" | undefined>;
        default: undefined;
    };
    required: {
        type: PropType<boolean | undefined>;
        default: undefined;
    };
    name: {
        type: PropType<string | undefined>;
        default: undefined;
    };
    disabled: {
        type: PropType<boolean | undefined>;
        default: undefined;
    };
    value: {
        type: PropType<string | undefined>;
        default: undefined;
    };
}>> & {
    onKeydown?: ((event: KeyboardEvent) => any) | undefined;
    onClick?: ((event: MouseEvent) => any) | undefined;
    "onUpdate:modelValue"?: ((checked: CheckedState) => any) | undefined;
    onCheckedChange?: ((checked: CheckedState) => any) | undefined;
}, () => (boolean | vue.VNode<vue.RendererNode, vue.RendererElement, {
    [key: string]: any;
}>)[], unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {
    'update:modelValue': (checked: CheckedState) => boolean;
    checkedChange: (checked: CheckedState) => boolean;
    keydown: (event: KeyboardEvent) => boolean;
    click: (event: MouseEvent) => boolean;
}, string, {
    checked: CheckedState;
    defaultChecked: boolean | "indeterminate" | undefined;
    disabled: boolean | undefined;
    name: string | undefined;
    required: boolean | undefined;
    value: string | undefined;
    modelValue: CheckedState;
    asChild: boolean;
}, {}, string, {}> & vue.VNodeProps & vue.AllowedComponentProps & vue.ComponentCustomProps & (new () => {
    $props: CheckboxNaviteElement;
});

type CheckboxIndicatorNaviteElement = OkuElement<'span'>;
interface CheckboxIndicatorProps extends PrimitiveProps {
    forceMount?: true;
}
declare const checkboxIndicatorProps: {
    props: {
        forceMount: {
            type: PropType<true | undefined>;
            default: undefined;
        };
    };
    emits: {};
};
declare const OkuCheckboxIndicator: {
    new (...args: any[]): {
        $: vue.ComponentInternalInstance;
        $data: {};
        $props: {
            asChild?: boolean | undefined;
            forceMount?: true | undefined;
            style?: unknown;
            class?: unknown;
            key?: string | number | symbol | undefined;
            ref?: vue.VNodeRef | undefined;
            ref_for?: boolean | undefined;
            ref_key?: string | undefined;
            readonly scopeOkuCheckbox?: _oku_ui_provide.Scope<any>;
            onVnodeBeforeMount?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeMounted?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeBeforeUpdate?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>, oldVNode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>, oldVNode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeUpdated?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>, oldVNode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>, oldVNode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeBeforeUnmount?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
            onVnodeUnmounted?: ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void) | ((vnode: vue.VNode<vue.RendererNode, vue.RendererElement, {
                [key: string]: any;
            }>) => void)[] | undefined;
        };
        $attrs: {
            [x: string]: unknown;
        };
        $refs: {
            [x: string]: unknown;
        };
        $slots: Readonly<{
            [name: string]: vue.Slot<any> | undefined;
        }>;
        $root: vue.ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, vue.ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null;
        $parent: vue.ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, vue.ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null;
        $emit: (event: string, ...args: any[]) => void;
        $el: any;
        $options: vue.ComponentOptionsBase<Readonly<vue.ExtractPropTypes<{
            asChild: BooleanConstructor;
            scopeOkuCheckbox: {
                type: PropType<_oku_ui_provide.Scope<any>>;
                required: boolean;
            };
            forceMount: {
                type: PropType<true | undefined>;
                default: undefined;
            };
        }>>, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
            [key: string]: any;
        }>, unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {}, string, {
            asChild: boolean;
            forceMount: true | undefined;
        }, {}, string, {}> & {
            beforeCreate?: ((() => void) | (() => void)[]) | undefined;
            created?: ((() => void) | (() => void)[]) | undefined;
            beforeMount?: ((() => void) | (() => void)[]) | undefined;
            mounted?: ((() => void) | (() => void)[]) | undefined;
            beforeUpdate?: ((() => void) | (() => void)[]) | undefined;
            updated?: ((() => void) | (() => void)[]) | undefined;
            activated?: ((() => void) | (() => void)[]) | undefined;
            deactivated?: ((() => void) | (() => void)[]) | undefined;
            beforeDestroy?: ((() => void) | (() => void)[]) | undefined;
            beforeUnmount?: ((() => void) | (() => void)[]) | undefined;
            destroyed?: ((() => void) | (() => void)[]) | undefined;
            unmounted?: ((() => void) | (() => void)[]) | undefined;
            renderTracked?: (((e: vue.DebuggerEvent) => void) | ((e: vue.DebuggerEvent) => void)[]) | undefined;
            renderTriggered?: (((e: vue.DebuggerEvent) => void) | ((e: vue.DebuggerEvent) => void)[]) | undefined;
            errorCaptured?: (((err: unknown, instance: vue.ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, vue.ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null, info: string) => boolean | void) | ((err: unknown, instance: vue.ComponentPublicInstance<{}, {}, {}, {}, {}, {}, {}, {}, false, vue.ComponentOptionsBase<any, any, any, any, any, any, any, any, any, {}, {}, string, {}>, {}, {}> | null, info: string) => boolean | void)[]) | undefined;
        };
        $forceUpdate: () => void;
        $nextTick: typeof vue.nextTick;
        $watch<T extends string | ((...args: any) => any)>(source: T, cb: T extends (...args: any) => infer R ? (args_0: R, args_1: R) => any : (...args: any) => any, options?: vue.WatchOptions<boolean> | undefined): vue.WatchStopHandle;
    } & Readonly<vue.ExtractPropTypes<{
        asChild: BooleanConstructor;
        scopeOkuCheckbox: {
            type: PropType<_oku_ui_provide.Scope<any>>;
            required: boolean;
        };
        forceMount: {
            type: PropType<true | undefined>;
            default: undefined;
        };
    }>> & vue.ShallowUnwrapRef<() => vue.VNode<vue.RendererNode, vue.RendererElement, {
        [key: string]: any;
    }>> & {} & vue.ComponentCustomProperties & {};
    __isFragment?: undefined;
    __isTeleport?: undefined;
    __isSuspense?: undefined;
} & vue.ComponentOptionsBase<Readonly<vue.ExtractPropTypes<{
    asChild: BooleanConstructor;
    scopeOkuCheckbox: {
        type: PropType<_oku_ui_provide.Scope<any>>;
        required: boolean;
    };
    forceMount: {
        type: PropType<true | undefined>;
        default: undefined;
    };
}>>, () => vue.VNode<vue.RendererNode, vue.RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, vue.ComponentOptionsMixin, vue.ComponentOptionsMixin, {}, string, {
    asChild: boolean;
    forceMount: true | undefined;
}, {}, string, {}> & vue.VNodeProps & vue.AllowedComponentProps & vue.ComponentCustomProps & (new () => {
    $props: CheckboxIndicatorNaviteElement;
});

export { type CheckboxElement, type CheckboxEmits, type CheckboxIndicatorNaviteElement, type CheckboxIndicatorProps, type CheckboxNaviteElement, type CheckboxProps, OkuCheckbox, OkuCheckboxIndicator, checkboxIndicatorProps, checkboxProps, createCheckboxScope };
